'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _merge2 = require('lodash/merge');

var _merge3 = _interopRequireDefault(_merge2);

var _isArray2 = require('lodash/isArray');

var _isArray3 = _interopRequireDefault(_isArray2);

var _isPlainObject2 = require('lodash/isPlainObject');

var _isPlainObject3 = _interopRequireDefault(_isPlainObject2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _createReactClass = require('create-react-class');

var _createReactClass2 = _interopRequireDefault(_createReactClass);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
  alert: {
    padding: '15px',
    border: '1px solid transparent',
    fontSize: '14px'
  },
  danger: {
    color: '#a94442',
    backgroundColor: '#f2dede',
    borderColor: '#ebccd1'
  }
};

exports.default = (0, _createReactClass2.default)({
  displayName: 'Error',

  propTypes: {
    error: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.array, _propTypes2.default.object]).isRequired
  },

  render: function render() {
    var error = this.props.error;

    var text = '';

    if ((0, _isPlainObject3.default)(error)) {
      text = JSON.stringify(error);
    } else if ((0, _isArray3.default)(error)) {
      text = JSON.stringify(error);
    } else {
      text = error;
    }

    return _react2.default.createElement(
      'div',
      { style: (0, _merge3.default)({}, styles.alert, styles.danger) },
      _react2.default.createElement(
        'strong',
        null,
        'Error!'
      ),
      ' ',
      text
    );
  }

});